import java.util.HashMap;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;


public class Compiler {
	
	public Compiler() {}
	
	public void compile(String scriptTxt) throws Exception {
		String lines[] = scriptTxt.replaceAll("\t", "").split("\n");
		
		lines = removeComments(lines);
		
		String fullCode = "";
		//build full code string and take out spaces
		for (int i = 0; i < lines.length; i++) {
			int codeStage = 0;
			for (int s = 0; s < lines[i].length(); s++) {
				if (codeStage == 2) {
					if (lines[i].charAt(s) == ';') {
						codeStage = 0;
					} else {
						if (lines[i].charAt(s) != ' ') {
							fullCode += lines[i].charAt(s);
						}
					}
				}
				if (codeStage == 1) {
					fullCode += lines[i].charAt(s);
					if (lines[i].charAt(s) == ')') {
						codeStage = 2;
					}
				}
				if (codeStage == 0) {
					if (lines[i].charAt(s) != ' ') {
						fullCode += lines[i].charAt(s);
					}
					if (lines[i].charAt(s) == '(') {
						codeStage = 1;
					}
				}
			}
		}
		
		String commands[] = fullCode.split(";");
		
		Command cBuf[] = new Command[commands.length];
		Function functions[] = new Function[128];
		
		//evaluate commands and compile
		int currMainCmd = 0;
		int currFuncId = 0;
		int currFuncCmdId = 0;
		int inFunction = -1;
		
		for (int i = 0; i < commands.length; i++) {
			Command c = compileCommand(commands[i]);
			if (inFunction == -1) {
				if (c.id == 2) {
					inFunction = currFuncId;
					functions[currFuncId] = new Function();
					functions[currFuncId].startIndex = i;
					functions[currFuncId].name = c.args[0];
					currFuncCmdId = 0;
				}
			} else {
				currFuncCmdId++;
				if (c.id == 3) {
					functions[currFuncId].endIndex = i-1;
					functions[currFuncId].length = functions[currFuncId].endIndex-functions[currFuncId].startIndex;
					currFuncId++;
					inFunction = -1;
				}
			}
			cBuf[i] = c;
			currMainCmd++;
		}
		
		HashMap<String, Function> funcMap = new HashMap<String, Function>();
		for (int i = 0; i < currFuncId; i++) {
			funcMap.put(functions[i].name, functions[i]);
		}
		
		Main.engine.run(cBuf, currMainCmd, funcMap);
	}
	
	private Command compileCommand(String commandStr) {
		String commandName = "",args = "";
		int codeStage = 0;
		for (int i = 0; i < commandStr.length(); i++) {
			if (codeStage == 1) {
				if (commandStr.charAt(i) != ')') {
					args += commandStr.charAt(i);
				}
			}
			if (codeStage == 0) {
				if (commandStr.charAt(i) == '(') {
					codeStage = 1;
				} else {
					commandName += commandStr.charAt(i);
				}
			}
		}
		return new Command(Command.GetIdFromName(commandName.toLowerCase()),args.split(","));
	}
	
	private String[] removeComments(String lns[]) {
		String newLines[];
		int newNumOfLines = 0;
		
		for (int i = 0; i < lns.length; i++) {
			if (lns[i].startsWith("//")) {
				lns[i] = "";
			} else {
				int commentPoint = lns[i].indexOf("//");
				if (commentPoint != -1) {
					lns[i] = lns[i].substring(0, lns[i].indexOf("//"));
				}
				newNumOfLines++;
			}
		}
		
		newLines = new String[newNumOfLines];
		newNumOfLines = 0;
		for (int i = 0; i < lns.length; i++) {
			if (lns[i] != "") {
				newLines[newNumOfLines] = lns[i];
				newNumOfLines++;
			}
		}
		
		return newLines;
	}
	
	String compileArg(String arg) {
		if (arg.charAt(0) == '~') {
			return Main.engine.getVariable(arg.substring(1));
		}
		return arg;
	}
}
