import java.awt.Color;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.awt.image.DataBufferInt;


public class FindColor extends EngineCommand {
	void execute(String args[]) {
		Rectangle capRect = new Rectangle();
		capRect.setBounds(Integer.parseInt(Main.compiler.compileArg(args[4])), Integer.parseInt(Main.compiler.compileArg(args[5])), Integer.parseInt(Main.compiler.compileArg(args[6])), Integer.parseInt(Main.compiler.compileArg(args[7])));

		int range = Integer.parseInt(Main.compiler.compileArg(args[8]));
		byte cR = Byte.parseByte(Main.compiler.compileArg(args[1]));
		byte cG = Byte.parseByte(Main.compiler.compileArg(args[2]));
		byte cB = Byte.parseByte(Main.compiler.compileArg(args[3]));
		int fC = getIntFromColor(cR,cG,cB);
		
		BufferedImage cap = Main.bot.createScreenCapture(capRect);
		final int px[] = ((DataBufferInt)cap.getRaster().getDataBuffer()).getData();
		int pxCol;
		int size = cap.getWidth()*cap.getHeight();
		int x = 0,y = 0;
		byte r,g,b;
		for (int i = 0; i < px.length; i++) {
			if (range != 0) {
				r = (byte) (px[i] >> 16 & 0xff);
				g = (byte) (px[i] >> 8 & 0xff);
				b = (byte) (px[i] & 0xff);
				if (r > cR-range && r < cR+range) {
					if (g > cG-range && g < cG+range) {
						if (b > cB-range && b < cB+range) {
							Main.engine.setVariable(args[0], (x+capRect.x)+","+(y+capRect.y));
							return;
						}
					}
				}
			} else {
				if (px[i] == fC) {
					Main.engine.setVariable(args[0], (x+capRect.x)+","+(y+capRect.y));
					return;
				}
			}
			
			x++;
			if (x == cap.getWidth()) {
				x = 0;
				y++;
			}
		}
		Main.engine.setVariable(args[0], "-1");
	}
	
	private int getIntFromColor(int Red, int Green, int Blue){
	    Red = (Red << 16) & 0x00FF0000;
	    Green = (Green << 8) & 0x0000FF00;
	    Blue = Blue & 0x000000FF;

	    return 0xFF000000 | Red | Green | Blue; 
	}
}
