import java.awt.AWTException;
import java.awt.Dimension;
import java.awt.Robot;
import java.awt.Toolkit;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;


public class Main {
	public final String TITLE = "IBot";
	public final String VERSION = "v1.0";
	
	private MainGUI mainUi;
	private ScriptGUI scriptUi;
	JFrame window;
	
	public Main() {
		mainUi = new MainGUI();
		scriptUi = new ScriptGUI();
		
		goNormalUi();
	}
	
	void setScriptText(String txt) {
		scriptUi.dtrpnhi.setText(txt);
	}
	void setPauseBtnText(String txt) {
		scriptUi.btnPause.setText(txt);
	}
	
	void goScriptUi(String scriptName) {
		if (window != null) {
			window.dispose();
			window = null;
		}
		
		window = new JFrame(TITLE + " " + VERSION + " - " + scriptName);
		window.setLayout(null);
		window.setAlwaysOnTop(true);
		window.setUndecorated(true);
		window.setResizable(false);
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		window.setSize(300,40);
		window.setLocation(Toolkit.getDefaultToolkit().getScreenSize().width-300,Toolkit.getDefaultToolkit().getScreenSize().height-84);
		
		scriptUi.btnPause.setText("Pause");
		
		window.add(scriptUi);
		
		window.setVisible(true);
	}
	
	void goNormalUi() {
		if (window != null) {
			window.dispose();
			window = null;
		}
		
		window = new JFrame(TITLE + " " + VERSION);
		window.setLayout(null);
		window.setAlwaysOnTop(true);
		window.setResizable(false);
		window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		window.setSize(900, 650);

		window.add(mainUi);
		
		window.setVisible(true);
		
		mainUi.refreshWindowTitle();
	}
	
	public static void main(String args[]) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (ClassNotFoundException | InstantiationException
				| IllegalAccessException | UnsupportedLookAndFeelException e) {}
		
		Main.main = new Main();
		Main.compiler = new Compiler();
		Main.engine = new Engine();
		try {
			Main.bot = new Robot();
		} catch (AWTException e) {
			JOptionPane.showMessageDialog(null, "Fatal Error\nFailed to initialize java.awt.Robot");
			System.exit(0);
		}
		Command.Init();
	}
	static Main main;
	static Compiler compiler;
	static Engine engine;
	static Robot bot;
	static void destroy(Object o) {
		o = null;
	}
}
