import javax.swing.JPanel;

import java.awt.FlowLayout;

import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

import java.awt.BorderLayout;

import javax.swing.BoxLayout;

import java.awt.Component;
import java.awt.Insets;

import javax.swing.JMenu;
import javax.swing.JSplitPane;

import java.awt.GridLayout;
import java.awt.MouseInfo;
import java.awt.Point;
import java.awt.ComponentOrientation;
import java.awt.PointerInfo;

import javax.swing.JInternalFrame;
import javax.swing.JTree;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.tree.DefaultMutableTreeNode;

import java.awt.CardLayout;

import javax.swing.GroupLayout;
import javax.swing.GroupLayout.Alignment;
import javax.swing.JFileChooser;
import javax.swing.JScrollPane;
import javax.swing.LayoutStyle.ComponentPlacement;
import javax.swing.Timer;

import java.awt.Color;

import javax.swing.JButton;
import javax.swing.JTextArea;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import javax.swing.JLabel;

import java.awt.Font;
import java.awt.SystemColor;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import javax.swing.UIManager;
import javax.swing.border.SoftBevelBorder;
import javax.swing.border.BevelBorder;
import javax.swing.border.MatteBorder;


public class MainGUI extends JPanel implements TreeSelectionListener,ActionListener {
	private JTextArea textArea;
	private JLabel lblNewLabel;
	private String loadedScriptName;
	private Timer t;
	
	public MainGUI() {
		setSize(900,650);
		setLocation(0, 0);
		setLayout(null);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(37, 70, 166, 534);
		add(scrollPane);
		
		DefaultMutableTreeNode root = buildNode("root");
		buildScriptingTree(root);
		JTree tree = new JTree(root);
		tree.setRootVisible(false);
		tree.addTreeSelectionListener(this);
		scrollPane.setViewportView(tree);
		
		JPanel panel = new JPanel();
		panel.setBorder(new MatteBorder(1, 1, 1, 1, (Color) new Color(0, 0, 0)));
		panel.setForeground(new Color(0, 0, 0));
		panel.setBackground(UIManager.getColor("CheckBox.light"));
		panel.setBounds(37, 29, 521, 30);
		add(panel);
		
		loadedScriptName = "";
		
		JButton btnLoad = new JButton("Load");
		btnLoad.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Main.main.window.setAlwaysOnTop(false);
				JFileChooser jfc = new JFileChooser();
				jfc.setCurrentDirectory(new File(System.getProperty("user.dir")));
				int retVal = jfc.showOpenDialog(null);
				if (retVal == JFileChooser.APPROVE_OPTION) {
					try {
						BufferedReader br = new BufferedReader(new FileReader(jfc.getSelectedFile().getAbsolutePath()));
						String file = "";
						String inBuf = "";
						while ((inBuf = br.readLine()) != null) {
							file += inBuf+"\n";
						}
						br.close();
						textArea.setText(file);
						loadedScriptName = jfc.getSelectedFile().getName();
						Main.main.window.setTitle(Main.main.TITLE + " " + Main.main.VERSION + " - " + loadedScriptName);
					} catch (FileNotFoundException e) {} catch (IOException e) {}
				}
			}
		});
		
		JButton btnNew = new JButton("New");
		btnNew.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				Main.main.window.setAlwaysOnTop(false);
				int result = JOptionPane.showConfirmDialog(null, "Are you sure?\n");
				if (result == JOptionPane.YES_OPTION) {
					textArea.setText("");
					loadedScriptName = "";
					Main.main.window.setTitle(Main.main.TITLE + " " + Main.main.VERSION);
				}
				Main.main.window.setAlwaysOnTop(true);
			}
		});
		panel.add(btnNew);
		panel.add(btnLoad);
		
		JButton btnSave = new JButton("Save");
		btnSave.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				Main.main.window.setAlwaysOnTop(false);
				String name = JOptionPane.showInputDialog("Desired script name:", loadedScriptName.length()!=0?loadedScriptName.substring(0, loadedScriptName.length()-3):"");
				if (name == null) {
					return;
				}
				File baseDir = new File("scripts//");
				if (!baseDir.exists()) {
					baseDir.mkdir();
				}
				
				try {
					File f = new File("scripts//"+name+".bs");
					PrintWriter out = new PrintWriter(f);
					out.print(textArea.getText());
					out.close();
					JOptionPane.showMessageDialog(null, "Script succesfully saved to " + System.getProperty("user.dir") + "//scripts//"+name+".bs");
					loadedScriptName = f.getName();
					Main.main.window.setTitle(Main.main.TITLE + " " + Main.main.VERSION + " - " + loadedScriptName);
				} catch (FileNotFoundException e1) {
					JOptionPane.showMessageDialog(null, e1.getStackTrace().toString());
				}
				Main.main.window.setAlwaysOnTop(true);
			}
		});
		panel.add(btnSave);
		
		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(213, 70, 651, 534);
		add(scrollPane_1);
		
		textArea = new JTextArea();
		scrollPane_1.setViewportView(textArea);
		
		JButton btnRun = new JButton("Run");
		btnRun.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					Main.compiler.compile(textArea.getText());
					Main.main.goScriptUi(loadedScriptName);
				} catch (Exception e1) {
					JOptionPane.showMessageDialog(null, e1.getStackTrace().toString());
					Main.main.goNormalUi();
				}
			}
		});
		panel.add(btnRun);
		
		lblNewLabel = new JLabel("");
		lblNewLabel.setForeground(Color.BLACK);
		lblNewLabel.setFont(new Font("Tahoma", Font.BOLD, 16));
		lblNewLabel.setBounds(568, 39, 332, 20);
		add(lblNewLabel);
		
		
		t = new Timer(250,this);
		new Thread(new Runnable() {
			public void run() {
				try {
					Thread.sleep(2000);
				} catch (InterruptedException e) {}
				t.start();
			}
		}).start();
	}
	
	private void buildScriptingTree(DefaultMutableTreeNode r) {
		DefaultMutableTreeNode ctrl = buildNode("Control");
		ctrl.add(buildNode("Set Mouse Position"));
		ctrl.add(buildNode("Key"));
		ctrl.add(buildNode("Mouse Down"));
		ctrl.add(buildNode("Mouse Up"));
		ctrl.add(buildNode("Tween Mouse"));
		ctrl.add(buildNode("Get Mouse X"));
		ctrl.add(buildNode("Get Mouse Y"));
		ctrl.add(buildNode("Get Pixel"));
		ctrl.add(buildNode("Find Color"));
		ctrl.add(buildNode("Get Screen Width"));
		ctrl.add(buildNode("Get Screen Height"));
		ctrl.add(buildNode("Wobble Mouse"));
		ctrl.add(buildNode("Type String"));
		
		DefaultMutableTreeNode script = buildNode("Script");
		script.add(buildNode("Wait"));
		script.add(buildNode("Start Function"));
		script.add(buildNode("End Function"));
		script.add(buildNode("Function"));
		script.add(buildNode("Popup"));
		script.add(buildNode("Set Script Text"));
		script.add(buildNode("Input Dialog"));
		script.add(buildNode("Option Dialog"));
		script.add(buildNode("Return"));
		
		
		DefaultMutableTreeNode math = buildNode("Math");
		math.add(buildNode("Add Int"));
		math.add(buildNode("Add Float"));
		math.add(buildNode("Add"));
		math.add(buildNode("If Bigger"));
		math.add(buildNode("If Smaller"));
		math.add(buildNode("Multiply"));
		math.add(buildNode("Divide"));
		math.add(buildNode("Sin"));
		math.add(buildNode("Cos"));
		math.add(buildNode("Round"));
		math.add(buildNode("Random Int"));
		math.add(buildNode("Random Float"));
		math.add(buildNode("Sub Int"));
		
		DefaultMutableTreeNode gen = buildNode("General");
		gen.add(buildNode("Variable"));
		gen.add(buildNode("If Equal"));
		gen.add(buildNode("End If"));
		gen.add(buildNode("If Not Equal"));
		gen.add(buildNode("Get From Array"));
		gen.add(buildNode("Get Red"));
		gen.add(buildNode("Get Green"));
		gen.add(buildNode("Get Blue"));
		gen.add(buildNode("Get X"));
		gen.add(buildNode("Get Y"));
		gen.add(buildNode("Get Array Length"));
		gen.add(buildNode("To Lower Case"));
		gen.add(buildNode("To Upper Case"));
		
		r.add(script);
		r.add(gen);
		r.add(math);
		r.add(ctrl);
	}
	private DefaultMutableTreeNode buildNode(String txt) {
		return new DefaultMutableTreeNode(txt);
	}

	
	public void valueChanged(TreeSelectionEvent e) {
		Object ps = ((DefaultMutableTreeNode)e.getPath().getLastPathComponent()).getUserObject();
		if (!ps.toString().equals("Control") && !ps.toString().equals("Script") && !ps.toString().equals("Math") && !ps.toString().equals("General")) {
			int id = Command.GetIdFromName(ps.toString().toLowerCase().replaceAll(" ",""));
			String out = ps.toString();
			
			switch (id) {
			case 0:
				out += "(x,y);";
				break;
				
			case 1:
				out += "(time to wait in milliseconds);";
				break;
				
			case 2:
				out += "(desired function name);";
				break;
			
			case 3:
				out +="();";
				break;
				
			case 4:
				out += "(name of function);";
				break;
				
			case 5:
				out += "(variable name,value);";
				break;
				
			case 6:
				out += "(value 1,value 2);";
				break;
				
			case 7:
				out += "();";
				break;
				
			case 8:
				out +="(variable name,integer);";
				break;
				
			case 9:
				out += "(variable name,float);";
				break;
				
			case 10:
				out += "(variable name,value);";
				break;
				
			case 11:
				out += "(value1,value2);";
				break;
				
			case 12:
				out += "(value1,value2);";
				break;
				
			case 13:
				out += "(value1,value2);";
				break;
				
			case 14:
				out += "(key,duration of key press in milliseconds);";
				break;
				
			case 15:
				out += "(button);";
				break;
				
			case 16:
				out += "(button);";
				break;
				
			case 17:
				out += "(x,y,duration in seconds);";
				break;
				
			case 18:
				out += "(text);";
				break;
				
			case 19:
				out += "(text/html);";
				break;
				
			case 20:
				out += "(variable name);";
				break;
				
			case 21:
				out += "(variable name);";
				break;
				
			case 22:
				out += "(text,variable name);";
				break;
				
			case 23:
				out += "(array,array index,destination variable name);";
				break;
				
			case 24:
				out += "(variable name,float);";
				break;
				
			case 25:
				out += "(variable name,float);";
				break;
				
			case 26:
				out += "(variable name);";
				break;
				
			case 27:
				out += "(variable name,value);";
				break;
				
			case 28:
				out += "(variable name,value);";
				break;
				
			case 29:
				out += "(variable name,x,y);";
				break;
				
			case 30:
				out += "(color,variable name);";
				break;
				
			case 31:
				out += "(color,variable name);";
				break;
				
			case 32:
				out += "(color,variable name);";
				break;
				
			case 33:
				out += "(variable name,red value,blue value,green value,x,y,width,height,range);";
				break;
				
			case 34:
				out += "(coordinate,variable name);";
				break;
				
			case 35:
				out += "(coordinate,variable name);";
				break;
				
			case 36:
				out += "(variable name,text,options...);";
				break;
				
			case 37:
				out += "(variable name,min,max);";
				break;
				
			case 38:
				out += "(variable name,min,max);";
				break;
				
			case 39:
				out += "(variable name);";
				break;
				
			case 40:
				out += "(variable name);";
				break;
				
			case 41:
				out += "();";
				break;
				
			case 42:
				out += "(variable name,integer);";
				break;
				
			case 43:
				out += "(text,variable name);";
				break;
				
			case 44:
				out += "(variable name);";
				break;
				
			case 45:
				out += "(variable name);";
				break;
			
			case 46:
				out += "(array variable name,variable name);";
				break;
				
			case 47:
				out += "(x,y,size of wobble,wobble speed,time);";
				break;
				
			case 48:
				out += "(text to type,duration);";
				break;
			}
			
			textArea.insert(out, textArea.getCaretPosition());
		}
	}
	
	void refreshWindowTitle() {
		if (Main.main == null) {
			return;
		}
		Main.main.window.setTitle(Main.main.TITLE + " " + Main.main.VERSION + " - " + loadedScriptName);
	}

	PointerInfo pIBuf;
	Color pCBuf;
	public void actionPerformed(ActionEvent a) {
		pIBuf = MouseInfo.getPointerInfo();
		pCBuf = Main.bot.getPixelColor(pIBuf.getLocation().x, pIBuf.getLocation().y);
		lblNewLabel.setText("Mouse Pos("+pIBuf.getLocation().x+","+pIBuf.getLocation().y+")Col("+pCBuf.getRed()+","+pCBuf.getGreen()+","+pCBuf.getBlue()+")");
	}
}
