import java.awt.MouseInfo;
import java.awt.Point;
import java.util.Random;


public class WobbleMouse extends EngineCommand {
	private final Random random = new Random();
	void execute(String[] args) {
		int targetX = Integer.parseInt(Main.compiler.compileArg(args[0]));
		int targetY = Integer.parseInt(Main.compiler.compileArg(args[1]));
		int wobbleSize = Integer.parseInt(Main.compiler.compileArg(args[2]));
		float wobbleSpeed = Float.parseFloat(Main.compiler.compileArg(args[3]));
		
		Point cursorPos = MouseInfo.getPointerInfo().getLocation();
		int velX = cursorPos.x-targetX;
		int velY = cursorPos.y-targetY;
		float velDir = (float) ((Math.atan2(velY, velX))-(Math.PI/2));
		float wobbleAmount = 0;
		boolean wobbleDir = false;
		
		long delta,now,last = System.currentTimeMillis();
		float time = 0;
		float mul = (float) (1.0/Float.parseFloat(args[4]));
		while (time < 1.0) {
			now = System.currentTimeMillis();
			delta = now-last;
			last = now;
			
			if (wobbleDir) {
				wobbleAmount += wobbleSpeed;
				if (wobbleAmount > wobbleSize) {
					wobbleDir = !wobbleDir;
				}
			} else {
				wobbleAmount -= wobbleSpeed;
				if (wobbleAmount < -wobbleSize) {
					wobbleDir = !wobbleDir;
				}
			}
			
			time += (delta/1000.0)*mul;
			Main.bot.mouseMove((int)(cursorPos.x+(Math.sin(velDir)*wobbleAmount)-(velX*time)), (int)(cursorPos.y+(Math.cos(velDir)*wobbleAmount)-(velY*time)));
			try {
				Thread.sleep(5);
			} catch (InterruptedException e) {}
		}
		Main.bot.mouseMove(targetX,targetY);
	}
	

}
